{

zLast Uploads v0.10
Copyright (c) 2001 by Brian Zhou
All Rights Reserved.

Props to g00r00, grymmjack, liquid and silica.

Modifications may be distributed, as long as proper credit is given.
The author is not responsible for any damage or destruction caused - directly
or indirectly - by this program.

Contact information:

email: zoob@darktech.org
web  : http://www.elysoft.org/zoob

}

Program zLastUp;

Uses dos;

{$I records.pas}

const
     prgName = 'zLast Uploads';
     prgVersion = '0.10';
     prgDesc = 'Extracts newest uploads in a filebase';
     prgAuthor = 'Brian Zhou';
     prgYear = '2001';

     fileFBase = 'fbases.dat';

     maxFiles = 100;

type
     fileRec = packed record
          frec : fDirRec;
          fpos : longint;
          date : longint;
     end;

var
     fBase    : file;
     fDir     : file;

     fOutput  : text;

     curBase  : fBaseRec;
     curDir   : fDirRec;

     fList    : array [1 .. maxFiles] of fileRec;
     fListNum : integer;

     pathData : string;
     pathOut  : string;
     ascending: boolean;
     baseNum  : integer;
     readNum  : integer;

(* convert a string to an int *)
function int2str(str : string) : integer;
var i, code : integer;
begin
     val(str, i, code);
     if (code <> 0) then
          i := -1;
     int2str := i;
end;

(* converts a string to uppercase *)
function upper(str : string) : string;
var i : integer; s : string;
begin
     s := '';
     for i := 1 to length(str) do
         s := s + upcase(str[i]);
     upper := s;
end;

(* sorts the file list according to date *)
procedure sortFList;
var i, j : integer; tempRec : fileRec;
begin
     for j := 1 to fListNum do
         for i := 1 to fListNum - 1 do begin
             if (fList[i].date > fList[i].date) and (ascending) then begin
                tempRec := fList[i + 1];
                fList[i + 1] := fList[i];
                fList[i] := tempRec;
             end;
         end;
end;

(* add a new file record into a sorted list *)
procedure addSortFList(fdir : fDirRec; fPos:longint);
var i, j : integer; newRec, tempRec : fileRec;
begin
     if (fListNum = 0) then begin
          fList[1].frec := fdir;
          fList[1].fpos := fpos;
          fList[1].date := fdir.datetime;
          fListNum := 1;
     end else begin
         newRec.fpos := fpos;
         newRec.frec := fdir;
         newRec.date := fdir.datetime;
         for i := 1 to fListNum + 1 do begin
             if (fListNum < maxFiles) and (i > fListNum - 1) then begin
                fList[i] := newRec;
                inc(fListNum);
                exit;
             end else
             if (fList[i].date < newRec.date) then begin
                if (fListNum < maxFiles) then
                    inc(fListNum);
                for j := fListNum downto i + 1 do
                     fList[j] := fList[j - 1];
                fList[i] := newRec;
                exit;
             end;
         end;
     end;
end;

(* open a file base data and grab data *)
function openReadFBase(which : integer) : boolean;
var ok : boolean;
var res : word;
begin
     ok := false;
     assign(fBase, pathData + fileFBase);
     {$i-}
     reset(fBase, sizeOf(fBaseRec));
     {$i+}
     if (ioResult = 0) then
     begin
          if (which > fileSize(fBase)) or (which < 0) then
               ok := false
          else
          begin
               seek(fBase, which);
               blockread(fBase, curBase, 1, res);
               ok := (res = sizeOf(fBaseRec));
          end;
          close(fBase);
     end;
end;

(* parse params *)
procedure getParams;
begin;
     pathData := paramStr(1);
     baseNum  := int2str(paramStr(2));
     readNum  := int2str(paramStr(3));
     ascending:= upper(paramStr(4)) = 'a';
     pathOut  := paramStr(5);
end;

(* open the .dir file and get the info *)
procedure openGetInfoFDir;
var i : integer; cFDir : fDirRec;
begin
     assign(fDir, pathData + curBase.filename + '.dir');
     {$i-} reset(fDir, sizeOf(fDirRec)); {$i+}
     for i := 1 to sizeOf(fDir) do begin
          {$i-} blockread(fDir, cFDir, 1); {$i+};
          if (ioResult = 0) then begin
              if (deleted in cFDir.flags) = false then
                 addSortFList(cFDir, filePos(fDir) - 1)
          end else
              exit;
     end;
     close(fDir);
end;

(* write the output data *)
procedure writeOutput;
var i, j : integer; dt : dateTime; s : string; fDesc : file;
begin
     assign(fDesc, pathData + curBase.fileName + '.des');
     reset(fDesc, 1);
     assign(fOutput, pathOut);
     rewrite(fOutput);
     writeln(fOutput, fListNum - 1);
     for i := 1 to fListNum - 1 do begin
         unpackTime(fList[i].date, dt);
         writeln(fOutput, fList[i].frec.filename);
         writeln(fOutput, fList[i].frec.size);
         writeln(fOutput, fList[i].frec.uploader);
         writeln(fOutput, fList[i].frec.dls);
         writeln(fOutput, fList[i].frec.datetime);
{         writeln(fOutput, dt.year, ' ', dt.month, ' ', dt.day, ' ', dt.hour, ' ', dt.min);}
         writeln(fOutput, fList[i].frec.lines);
         seek(fDesc, fList[i].frec.pointer);
         for j := 1 to fList[i].frec.lines do begin
             blockread(fDesc, s[0], 1);
             blockread(fDesc, s[1], ord(s[0]));
             writeln(fOutput, s);
             s := '';
         end;
     end;
     close(fOutput);
     close(fDesc);
end;

(* main block *)
begin
     fillChar(fList, sizeOf(fList), 0);
     fListNum := 0;
     writeln(prgName + ' Version ' + prgVersion + ' - ' + prgDesc);
     writeln('Copyright (C) ' + prgYear + ' by Brian Zhou.  All rights reserved.');
     writeln;
     if (paramCount <> 5) then begin
          writeln('Program usage:');
          writeln;
          writeln('ZLASTUP.EXE <data path> <base #> <# read> <[a]scending/[d]escending> <output>');
          writeln;
          writeln('Example:');
          writeln;
          writeln('To get 10 uploads in ascending order:');
          writeln('zlastup.exe c:\mystic\data\ 0 10 a c:\mystic\lastup.0');
          writeln;
          halt(1);
     end;

     getParams;
     if (openReadFBase(baseNum) = false) then begin
        writeln('ERROR: Unable to read base ', baseNum, '!  Aborting.');
        halt(1);
     end;
     openGetInfoFDir;
     writeOutput;
end.
